# Couenne::expression Class Reference

Expression base class. More...

`#include <CouenneExpression.hpp>`

Inheritance diagram for Couenne::expression:

List of all members.

## Public Types
enum | auxSign { AUX_UNDEF = -2, AUX_LEQ = -1, AUX_EQ, AUX_GEQ }
| "sign" of the constraint defining an auxiliary. More...
## Public Member Functions
| expression ()
| Constructor.
| expression (const expression &e, Domain *d=NULL)
| Copy constructor.
virtual | ~expression ()
| Destructor.
virtual expression * | clone (Domain *d=NULL) const
| Cloning method.
virtual int | Index () const
| Return index of variable (only valid for exprVar and exprAux).
virtual int | nArgs () const
| return number of arguments (when applicable, that is, with N-ary functions)
virtual expression ** | ArgList () const
| return arglist (when applicable, that is, with N-ary functions)
virtual void | ArgList (expression **al)
| set arglist (used in deleting nodes without deleting children)
virtual expression * | Argument () const
| return argument (when applicable, i.e., with univariate functions)
virtual expression ** | ArgPtr ()
| return pointer to argument (when applicable, i.e., with univariate functions)
virtual enum nodeType | Type () const
| node type
virtual expression * | Image () const
| return pointer to corresponding expression (for auxiliary variables only)
virtual void | Image (expression *image)
| set expression associated with this auxiliary variable (for compatibility with exprAux)
virtual CouNumber | Value () const
| value (empty)
virtual const expression * | Original () const
| If this is an exprClone of a exprClone of an expr???, point to the original expr??? instead of an exprClone -- improve computing efficiency.
virtual void | print (std::ostream &s=std::cout, bool=false) const
| print expression to iostream
virtual CouNumber | operator() ()=0
| null function for evaluating the expression
virtual CouNumber | gradientNorm (const double *x)
| return l-2 norm of gradient at given point
virtual expression * | differentiate (int)
| differentiation
virtual int | dependsOn (int *ind, int n, enum dig_type type=STOP_AT_AUX)
| dependence on variable set: return cardinality of subset of the set of indices in first argument which occur in expression.
int | dependsOn (int singleton, enum dig_type type=STOP_AT_AUX)
| version with one index only
virtual int | DepList (std::set< int > &deplist, enum dig_type type=ORIG_ONLY)
| fill std::set with indices of variables on which this expression depends.
virtual expression * | simplify ()
| simplify expression (useful for derivatives)
virtual int | Linearity ()
| get a measure of "how linear" the expression is (see CouenneTypes.h)
virtual bool | isDefinedInteger ()
| is this expression defined as an integer?
virtual bool | isInteger ()
| is this expression integer?
virtual void | getBounds (expression *&, expression *&)
| Get lower and upper bound of an expression (if any).
virtual void | getBounds (CouNumber &, CouNumber &)
| Get lower and upper bound of an expression (if any) -- real values.
virtual exprAux * | standardize (CouenneProblem *p, bool addAux=true)
| Create standard form of this expression, by:.
virtual void | generateCuts (expression *w, OsiCuts &cs, const CouenneCutGenerator *cg, t_chg_bounds *chg=NULL, int wind=-1, CouNumber lb=-COUENNE_INFINITY, CouNumber ub=COUENNE_INFINITY)
| generate convexification cut for constraint w = this
virtual enum expr_type | code ()
| return integer for comparing expressions (used to recognize common expression)
virtual enum convexity | convexity () const
| either CONVEX, CONCAVE, AFFINE, or NONCONVEX
virtual int | compare (expression &)
| compare expressions
virtual int | compare (exprCopy &)
| compare copies of expressions
virtual int | rank ()
| used in rank-based branching variable choice: original variables have rank 1; auxiliary w=f(x) has rank r(w) = r(x)+1; finally, auxiliary w=f(x1,x2.
virtual bool | impliedBound (int, CouNumber *, CouNumber *, t_chg_bounds *, enum auxSign=expression::AUX_EQ)
| does a backward implied bound processing on every expression, including exprSums although already done by Clp (useful when repeated within Couenne).
virtual int | Multiplicity ()
| multiplicity of a variable
virtual CouNumber | selectBranch (const CouenneObject *obj, const OsiBranchingInformation *info, expression *&var, double *&brpts, double *&brDist, int &way)
| set up branching object by evaluating many branching points for each expression's arguments.
virtual void | replace (exprVar *, exprVar *)
| replace expression with another
virtual void | fillDepSet (std::set< DepNode *, compNode > *, DepGraph *)
| update dependence set with index of variables on which this expression depends
virtual void | linkDomain (Domain *d)
| empty function to update domain pointer
virtual void | realign (const CouenneProblem *p)
| empty function to redirect variables to proper variable vector
virtual bool | isBijective () const
| indicating if function is monotonically increasing
virtual CouNumber | inverse (expression *vardep) const
| compute the inverse function
virtual void | closestFeasible (expression *varind, expression *vardep, CouNumber &left, CouNumber &right) const
| closest feasible points in function in both directions
virtual bool | isCuttable (CouenneProblem *problem, int index) const
| can this expression be further linearized or are we on its concave ("bad") side
virtual bool | isaCopy () const
| return true if this is a copy of something (i.e. an exprCopy)
virtual expression * | Copy () const
| return copy of this expression (only makes sense in exprCopy)

## Detailed Description

Expression base class.

An empty expression class with no type or operator() from which all other expression classes (for constants, variables, and operators) are derived.

Definition at line 48 of file CouenneExpression.hpp.

## Member Enumeration Documentation

enum Couenne::expression::auxSign

"sign" of the constraint defining an auxiliary.

If the auxiliary is defined as , then it is LEQ. It is EQ and GEQ, respectively, if it is defined with and .

Enumerator:

  AUX_UNDEF |
  AUX_LEQ |
  AUX_EQ |
  AUX_GEQ |

Definition at line 55 of file CouenneExpression.hpp.

## Constructor & Destructor Documentation

Couenne::expression::expression | ( |  | ) | `[inline]`

Constructor.

Definition at line 58 of file CouenneExpression.hpp.

Couenne::expression::expression | ( | const expression & | e,
|  | Domain * | d = `NULL` |
| ) |  |  | `[inline]`

Copy constructor.

Pass pointer to variable vector when generating new problem, whose set of variables is equivalent but may be changed or whose value is independent.

Definition at line 63 of file CouenneExpression.hpp.

virtual Couenne::expression::~expression | ( |  | ) | `[inline, virtual]`

Destructor.

Definition at line 66 of file CouenneExpression.hpp.

## Member Function Documentation

virtual expression* Couenne::expression::clone | ( | Domain * | d = `NULL` | ) | const`[inline, virtual]`

Cloning method.

Reimplemented in Couenne::exprAux, Couenne::exprLowerBound, Couenne::exprUpperBound, Couenne::exprClone, Couenne::exprConst, Couenne::exprCopy, Couenne::exprIVar, Couenne::exprStore, Couenne::exprVar, Couenne::exprLBCos, Couenne::exprUBCos, Couenne::exprLBDiv, Couenne::exprUBDiv, Couenne::exprLBMul, Couenne::exprUBMul, Couenne::exprLBQuad, Couenne::exprUBQuad, Couenne::exprLBSin, Couenne::exprUBSin, Couenne::exprAbs, Couenne::exprCeil, Couenne::exprCos, Couenne::exprDiv, Couenne::exprExp, Couenne::exprFloor, Couenne::exprGroup, Couenne::exprInv, Couenne::exprLog, Couenne::exprMax, Couenne::exprMin, Couenne::exprOddPow, Couenne::exprOpp, Couenne::exprPow, Couenne::exprQuad, Couenne::exprSin, Couenne::exprSub, and Couenne::exprSum.

Definition at line 69 of file CouenneExpression.hpp.

Referenced by Couenne::exprOp::clonearglist().

virtual int Couenne::expression::Index | ( |  | ) | const`[inline, virtual]`

Return index of variable (only valid for exprVar and exprAux).

Reimplemented in Couenne::exprCopy, and Couenne::exprVar.

Definition at line 73 of file CouenneExpression.hpp.

Referenced by Couenne::exprSin::gradientNorm(), Couenne::exprOpp::gradientNorm(), Couenne::exprFloor::gradientNorm(), Couenne::exprExp::gradientNorm(), Couenne::exprCos::gradientNorm(), Couenne::exprCeil::gradientNorm(), Couenne::exprAbs::gradientNorm(), Couenne::exprSin::impliedBound(), Couenne::exprCos::impliedBound(), and Couenne::exprQuad::operator()().

virtual int Couenne::expression::nArgs | ( |  | ) | const`[inline, virtual]`

return number of arguments (when applicable, that is, with N-ary functions)

Reimplemented in Couenne::exprCopy, Couenne::exprOp, and Couenne::exprUnary.

Definition at line 77 of file CouenneExpression.hpp.

virtual expression** Couenne::expression::ArgList | ( |  | ) | const`[inline, virtual]`

return arglist (when applicable, that is, with N-ary functions)

Reimplemented in Couenne::exprCopy, and Couenne::exprOp.

Definition at line 81 of file CouenneExpression.hpp.

virtual void Couenne::expression::ArgList | ( | expression ** | al | ) | `[inline, virtual]`

set arglist (used in deleting nodes without deleting children)

Definition at line 85 of file CouenneExpression.hpp.

virtual expression* Couenne::expression::Argument | ( |  | ) | const`[inline, virtual]`

return argument (when applicable, i.e., with univariate functions)

Reimplemented in Couenne::exprCopy, and Couenne::exprUnary.

Definition at line 88 of file CouenneExpression.hpp.

virtual expression** Couenne::expression::ArgPtr | ( |  | ) | `[inline, virtual]`

return pointer to argument (when applicable, i.e., with univariate functions)

Reimplemented in Couenne::exprCopy, and Couenne::exprUnary.

Definition at line 92 of file CouenneExpression.hpp.

virtual enum nodeType Couenne::expression::Type | ( |  | ) | const`[inline, virtual]`

node type

Reimplemented in Couenne::exprAux, Couenne::exprLowerBound, Couenne::exprUpperBound, Couenne::exprConst, Couenne::exprCopy, Couenne::exprOp, Couenne::exprUnary, and Couenne::exprVar.

Definition at line 96 of file CouenneExpression.hpp.

References Couenne::EMPTY.

virtual expression* Couenne::expression::Image | ( |  | ) | const`[inline, virtual]`

return pointer to corresponding expression (for auxiliary variables only)

Reimplemented in Couenne::exprAux, and Couenne::exprCopy.

Definition at line 100 of file CouenneExpression.hpp.

virtual void Couenne::expression::Image | ( | expression * | image | ) | `[inline, virtual]`

set expression associated with this auxiliary variable (for compatibility with exprAux)

Definition at line 105 of file CouenneExpression.hpp.

virtual CouNumber Couenne::expression::Value | ( |  | ) | const`[inline, virtual]`

value (empty)

Reimplemented in Couenne::exprClone, Couenne::exprConst, and Couenne::exprCopy.

Definition at line 108 of file CouenneExpression.hpp.

virtual const expression* Couenne::expression::Original | ( |  | ) | const`[inline, virtual]`

If this is an exprClone of a exprClone of an expr???, point to the original expr??? instead of an exprClone -- improve computing efficiency.

Only overloaded for exprClones/exprCopy, of course.

Reimplemented in Couenne::exprCopy.

Definition at line 114 of file CouenneExpression.hpp.

virtual void Couenne::expression::print | ( | std::ostream & | s = `std::cout`,
|  | bool | = `false` |
| ) |  |  | const`[inline, virtual]`

print expression to iostream

descend into auxiliaries' image?

Reimplemented in Couenne::exprAux, Couenne::exprLowerBound, Couenne::exprUpperBound, Couenne::exprClone, Couenne::exprConst, Couenne::exprCopy, Couenne::exprIVar, Couenne::exprOp, Couenne::exprStore, Couenne::exprUnary, Couenne::exprVar, Couenne::exprLBQuad, Couenne::exprUBQuad, Couenne::exprGroup, Couenne::exprInv, Couenne::exprOpp, and Couenne::exprQuad.

Definition at line 118 of file CouenneExpression.hpp.

virtual CouNumber Couenne::expression::operator() | ( |  | ) | `[pure virtual]`

null function for evaluating the expression

Implemented in Couenne::exprAux, Couenne::exprLowerBound, Couenne::exprUpperBound, Couenne::exprClone, Couenne::exprConst, Couenne::exprCopy, Couenne::exprStore, Couenne::exprUnary, Couenne::exprVar, Couenne::exprLBCos, Couenne::exprUBCos, Couenne::exprLBDiv, Couenne::exprUBDiv, Couenne::exprLBMul, Couenne::exprUBMul, Couenne::exprLBQuad, Couenne::exprUBQuad, Couenne::exprLBSin, Couenne::exprUBSin, Couenne::exprDiv, Couenne::exprGroup, Couenne::exprMax, Couenne::exprMin, Couenne::exprOddPow, Couenne::exprPow, Couenne::exprQuad, Couenne::exprSub, and Couenne::exprSum.

virtual CouNumber Couenne::expression::gradientNorm | ( | const double * | x | ) | `[inline, virtual]`

return l-2 norm of gradient at given point

Reimplemented in Couenne::exprCopy, Couenne::exprVar, Couenne::exprAbs, Couenne::exprCeil, Couenne::exprCos, Couenne::exprDiv, Couenne::exprExp, Couenne::exprFloor, Couenne::exprGroup, Couenne::exprInv, Couenne::exprLog, Couenne::exprOpp, Couenne::exprPow, Couenne::exprQuad, and Couenne::exprSin.

Definition at line 126 of file CouenneExpression.hpp.

virtual expression* Couenne::expression::differentiate | ( | int |  | ) | `[virtual]`

differentiation

Reimplemented in Couenne::exprLowerBound, Couenne::exprUpperBound, Couenne::exprConst, Couenne::exprCopy, Couenne::exprVar, Couenne::exprAbs, Couenne::exprCeil, Couenne::exprCos, Couenne::exprDiv, Couenne::exprExp, Couenne::exprFloor, Couenne::exprGroup, Couenne::exprInv, Couenne::exprLog, Couenne::exprMax, Couenne::exprMin, Couenne::exprOpp, Couenne::exprPow, Couenne::exprQuad, Couenne::exprSin, Couenne::exprSub, and Couenne::exprSum.

virtual int Couenne::expression::dependsOn | ( | int * | ind,
|  | int | n,
|  | enum dig_type | type = `STOP_AT_AUX` |
| ) |  |  | `[virtual]`

dependence on variable set: return cardinality of subset of the set of indices in first argument which occur in expression.

Reimplemented in Couenne::exprLowerBound, Couenne::exprUpperBound, and Couenne::exprConst.

int Couenne::expression::dependsOn | ( | int | singleton,
|  | enum dig_type | type = `STOP_AT_AUX` |
| ) |  |  | `[inline]`

version with one index only

Definition at line 137 of file CouenneExpression.hpp.

References dependsOn().

Referenced by dependsOn().

virtual int Couenne::expression::DepList | ( | std::set< int > & | deplist,
|  | enum dig_type | type = `ORIG_ONLY` |
| ) |  |  | `[inline, virtual]`

fill std::set with indices of variables on which this expression depends.

Also deal with expressions that have no variable pointers (exprGroup, exprQuad)

Reimplemented in Couenne::exprAux, Couenne::exprCopy, Couenne::exprOp, Couenne::exprUnary, Couenne::exprVar, Couenne::exprGroup, and Couenne::exprQuad.

Definition at line 143 of file CouenneExpression.hpp.

virtual expression* Couenne::expression::simplify | ( |  | ) | `[inline, virtual]`

simplify expression (useful for derivatives)

Reimplemented in Couenne::exprAux, Couenne::exprCopy, Couenne::exprOp, Couenne::exprUnary, Couenne::exprVar, Couenne::exprDiv, Couenne::exprGroup, Couenne::exprMax, Couenne::exprMin, Couenne::exprOpp, Couenne::exprPow, Couenne::exprQuad, Couenne::exprSub, and Couenne::exprSum.

Definition at line 148 of file CouenneExpression.hpp.

virtual int Couenne::expression::Linearity | ( |  | ) | `[inline, virtual]`

get a measure of "how linear" the expression is (see CouenneTypes.h)

Reimplemented in Couenne::exprAux, Couenne::exprLowerBound, Couenne::exprUpperBound, Couenne::exprConst, Couenne::exprCopy, Couenne::exprOp, Couenne::exprUnary, Couenne::exprVar, Couenne::exprDiv, Couenne::exprGroup, Couenne::exprInv, Couenne::exprMax, Couenne::exprMin, Couenne::exprOpp, Couenne::exprPow, Couenne::exprQuad, Couenne::exprSub, and Couenne::exprSum.

Definition at line 152 of file CouenneExpression.hpp.

References Couenne::NONLINEAR.

virtual bool Couenne::expression::isDefinedInteger | ( |  | ) | `[inline, virtual]`

is this expression defined as an integer?

Reimplemented in Couenne::exprAux, Couenne::exprCopy, Couenne::exprIVar, and Couenne::exprVar.

Definition at line 156 of file CouenneExpression.hpp.

References isInteger().

virtual bool Couenne::expression::isInteger | ( |  | ) | `[inline, virtual]`

is this expression integer?

Reimplemented in Couenne::exprAux, Couenne::exprConst, Couenne::exprCopy, Couenne::exprIVar, Couenne::exprOp, Couenne::exprUnary, Couenne::exprVar, Couenne::exprAbs, Couenne::exprDiv, Couenne::exprGroup, Couenne::exprOpp, Couenne::exprPow, and Couenne::exprQuad.

Definition at line 160 of file CouenneExpression.hpp.

Referenced by isDefinedInteger().

virtual void Couenne::expression::getBounds | ( | expression *& | ,
|  | expression *& |  |
| ) |  |  | `[virtual]`

Get lower and upper bound of an expression (if any).

virtual void Couenne::expression::getBounds | ( | CouNumber & | ,
|  | CouNumber & |  |
| ) |  |  | `[virtual]`

Get lower and upper bound of an expression (if any) -- real values.

Reimplemented in Couenne::exprConst, Couenne::exprCopy, Couenne::exprVar, Couenne::exprAbs, Couenne::exprCeil, Couenne::exprCos, Couenne::exprDiv, Couenne::exprExp, Couenne::exprFloor, Couenne::exprGroup, Couenne::exprInv, Couenne::exprLog, Couenne::exprOddPow, Couenne::exprOpp, Couenne::exprPow, Couenne::exprQuad, Couenne::exprSin, Couenne::exprSub, and Couenne::exprSum.

virtual exprAux* Couenne::expression::standardize | ( | CouenneProblem * | p,
|  | bool | addAux = `true` |
| ) |  |  | `[inline, virtual]`

Create standard form of this expression, by:.

- creating auxiliary w variables and corresponding expressions
- returning linear counterpart as new constraint (to replace current one)

For the base exprOp class we only do the first part (for argument list components only), and the calling class (Sum, Sub, Mul, Pow, and the like) will do the part for its own object

addAux is true if a new auxiliary variable should be added associated with the standardized expression

Reimplemented in Couenne::exprCopy, Couenne::exprOp, Couenne::exprUnary, Couenne::exprDiv, Couenne::exprMax, Couenne::exprMin, Couenne::exprOddPow, Couenne::exprOpp, Couenne::exprPow, Couenne::exprSub, and Couenne::exprSum.

Definition at line 181 of file CouenneExpression.hpp.

virtual void Couenne::expression::generateCuts | ( | expression * | w,
|  | OsiCuts & | cs,
|  | const CouenneCutGenerator * | cg,
|  | t_chg_bounds * | chg = `NULL`,
|  | int | wind = `-1`,
|  | CouNumber | lb = `-COUENNE_INFINITY`,
|  | CouNumber | ub = `COUENNE_INFINITY` |
| ) |  |  | `[inline, virtual]`

generate convexification cut for constraint w = this

Definition at line 185 of file CouenneExpression.hpp.

virtual enum expr_type Couenne::expression::code | ( |  | ) | `[inline, virtual]`

return integer for comparing expressions (used to recognize common expression)

Reimplemented in Couenne::exprLowerBound, Couenne::exprUpperBound, Couenne::exprConst, Couenne::exprCopy, Couenne::exprOp, Couenne::exprUnary, Couenne::exprVar, Couenne::exprAbs, Couenne::exprCeil, Couenne::exprCos, Couenne::exprDiv, Couenne::exprExp, Couenne::exprFloor, Couenne::exprGroup, Couenne::exprInv, Couenne::exprLog, Couenne::exprMax, Couenne::exprMin, Couenne::exprOddPow, Couenne::exprOpp, Couenne::exprPow, Couenne::exprQuad, Couenne::exprSin, Couenne::exprSub, and Couenne::exprSum.

Definition at line 193 of file CouenneExpression.hpp.

References Couenne::COU_EXPRESSION.

virtual enum convexity Couenne::expression::convexity | ( |  | ) | const`[inline, virtual]`

either CONVEX, CONCAVE, AFFINE, or NONCONVEX

Reimplemented in Couenne::exprCopy, and Couenne::exprVar.

Definition at line 197 of file CouenneExpression.hpp.

References Couenne::NONCONVEX.

virtual int Couenne::expression::compare | ( | expression & |  | ) | `[virtual]`

compare expressions

Reimplemented in Couenne::exprOp, Couenne::exprUnary, Couenne::exprGroup, and Couenne::exprQuad.

virtual int Couenne::expression::compare | ( | exprCopy & |  | ) | `[virtual]`

compare copies of expressions

virtual int Couenne::expression::rank | ( |  | ) | `[inline, virtual]`

used in rank-based branching variable choice: original variables have rank 1; auxiliary w=f(x) has rank r(w) = r(x)+1; finally, auxiliary w=f(x1,x2.

..,xk) has rank r(w) = 1+max{r(xi):i=1..k}.

Reimplemented in Couenne::exprAux, Couenne::exprConst, Couenne::exprCopy, Couenne::exprOp, Couenne::exprUnary, Couenne::exprVar, Couenne::exprGroup, and Couenne::exprQuad.

Definition at line 209 of file CouenneExpression.hpp.

virtual bool Couenne::expression::impliedBound | ( | int | ,
|  | CouNumber * | ,
|  | CouNumber * | ,
|  | t_chg_bounds * | ,
|  | enum | auxSign = `expression::AUX_EQ` |
| ) |  |  | `[inline, virtual]`

does a backward implied bound processing on every expression, including exprSums although already done by Clp (useful when repeated within Couenne).

Parameters are the index of the (auxiliary) variable in question and the current lower/upper bound. The method returns true if there has been a change on any bound on the variables on which the expression depends.

Reimplemented in Couenne::exprVar, Couenne::exprAbs, Couenne::exprCeil, Couenne::exprCos, Couenne::exprDiv, Couenne::exprExp, Couenne::exprFloor, Couenne::exprInv, Couenne::exprLog, Couenne::exprOddPow, Couenne::exprOpp, Couenne::exprPow, Couenne::exprQuad, Couenne::exprSin, Couenne::exprSub, and Couenne::exprSum.

Definition at line 218 of file CouenneExpression.hpp.

virtual int Couenne::expression::Multiplicity | ( |  | ) | `[inline, virtual]`

multiplicity of a variable

Reimplemented in Couenne::exprAux, and Couenne::exprCopy.

Definition at line 222 of file CouenneExpression.hpp.

virtual CouNumber Couenne::expression::selectBranch | ( | const CouenneObject * | obj,
|  | const OsiBranchingInformation * | info,
|  | expression *& | var,
|  | double *& | brpts,
|  | double *& | brDist,
|  | int & | way |
| ) |  |  | `[inline, virtual]`

set up branching object by evaluating many branching points for each expression's arguments.

Return estimated improvement in objective function

Definition at line 228 of file CouenneExpression.hpp.

virtual void Couenne::expression::replace | ( | exprVar * | ,
|  | exprVar * |  |
| ) |  |  | `[inline, virtual]`

replace expression with another

Reimplemented in Couenne::exprCopy, Couenne::exprOp, Couenne::exprUnary, Couenne::exprGroup, and Couenne::exprQuad.

Definition at line 238 of file CouenneExpression.hpp.

virtual void Couenne::expression::fillDepSet | ( | std::set< DepNode *, compNode > * | ,
|  | DepGraph * |  |
| ) |  |  | `[inline, virtual]`

update dependence set with index of variables on which this expression depends

Reimplemented in Couenne::exprCopy, Couenne::exprOp, Couenne::exprUnary, Couenne::exprVar, Couenne::exprGroup, and Couenne::exprQuad.

Definition at line 242 of file CouenneExpression.hpp.

virtual void Couenne::expression::linkDomain | ( | Domain * | d | ) | `[inline, virtual]`

empty function to update domain pointer

Reimplemented in Couenne::exprAux, and Couenne::exprVar.

Definition at line 245 of file CouenneExpression.hpp.

virtual void Couenne::expression::realign | ( | const CouenneProblem * | p | ) | `[inline, virtual]`

empty function to redirect variables to proper variable vector

Reimplemented in Couenne::exprCopy, Couenne::exprOp, Couenne::exprUnary, Couenne::exprGroup, and Couenne::exprQuad.

Definition at line 248 of file CouenneExpression.hpp.

virtual bool Couenne::expression::isBijective | ( |  | ) | const`[inline, virtual]`

indicating if function is monotonically increasing

Reimplemented in Couenne::exprCopy, Couenne::exprExp, Couenne::exprInv, and Couenne::exprLog.

Definition at line 251 of file CouenneExpression.hpp.

virtual CouNumber Couenne::expression::inverse | ( | expression * | vardep | ) | const`[inline, virtual]`

compute the inverse function

Definition at line 255 of file CouenneExpression.hpp.

References COUENNE_INFINITY.

virtual void Couenne::expression::closestFeasible | ( | expression * | varind,
|  | expression * | vardep,
|  | CouNumber & | left,
|  | CouNumber & | right |
| ) |  |  | const`[virtual]`

closest feasible points in function in both directions

virtual bool Couenne::expression::isCuttable | ( | CouenneProblem * | problem,
|  | int | index |
| ) |  |  | const`[inline, virtual]`

can this expression be further linearized or are we on its concave ("bad") side

Reimplemented in Couenne::exprCopy, Couenne::exprAbs, Couenne::exprCeil, Couenne::exprCos, Couenne::exprDiv, Couenne::exprExp, Couenne::exprFloor, Couenne::exprInv, Couenne::exprLog, Couenne::exprOddPow, Couenne::exprPow, Couenne::exprQuad, and Couenne::exprSin.

Definition at line 264 of file CouenneExpression.hpp.

virtual bool Couenne::expression::isaCopy | ( |  | ) | const`[inline, virtual]`

return true if this is a copy of something (i.e. an exprCopy)

Reimplemented in Couenne::exprCopy.

Definition at line 268 of file CouenneExpression.hpp.

virtual expression* Couenne::expression::Copy | ( |  | ) | const`[inline, virtual]`

return copy of this expression (only makes sense in exprCopy)

Reimplemented in Couenne::exprCopy.

Definition at line 272 of file CouenneExpression.hpp.

The documentation for this class was generated from the following file:

- CouenneExpression.hpp

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines